var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import clsx from 'clsx';
import { Transition } from 'react-transition-group';

/**
 * @ignore - internal component.
 */
function Ripple(props) {
  var _clsx, _clsx2;

  var _props$classes = props.classes,
      classes = _props$classes === undefined ? {} : _props$classes,
      className = props.className,
      _props$pulsate = props.pulsate,
      pulsate = _props$pulsate === undefined ? false : _props$pulsate,
      rippleX = props.rippleX,
      rippleY = props.rippleY,
      rippleSize = props.rippleSize,
      other = _objectWithoutProperties(props, ['classes', 'className', 'pulsate', 'rippleX', 'rippleY', 'rippleSize']);

  var _React$useState = React.useState(false),
      visible = _React$useState[0],
      setVisible = _React$useState[1];

  var _React$useState2 = React.useState(false),
      leaving = _React$useState2[0],
      setLeaving = _React$useState2[1];

  var handleEnter = function handleEnter() {
    setVisible(true);
  };

  var handleExit = function handleExit() {
    setLeaving(true);
  };

  var rippleClassName = clsx(classes.ripple, (_clsx = {}, _clsx[classes.rippleVisible] = visible, _clsx[classes.ripplePulsate] = pulsate, _clsx), className);

  var rippleStyles = {
    width: rippleSize,
    height: rippleSize,
    top: -(rippleSize / 2) + rippleY,
    left: -(rippleSize / 2) + rippleX
  };

  var childClassName = clsx(classes.child, (_clsx2 = {}, _clsx2[classes.childLeaving] = leaving, _clsx2[classes.childPulsate] = pulsate, _clsx2));

  return React.createElement(
    Transition,
    _extends({ onEnter: handleEnter, onExit: handleExit }, other),
    React.createElement(
      'span',
      { className: rippleClassName, style: rippleStyles },
      React.createElement('span', { className: childClassName })
    )
  );
}

Ripple.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: PropTypes.object.isRequired,
  /**
   * @ignore
   */
  className: PropTypes.string,
  /**
   * If `true`, the ripple pulsates, typically indicating the keyboard focus state of an element.
   */
  pulsate: PropTypes.bool,
  /**
   * Diameter of the ripple.
   */
  rippleSize: PropTypes.number,
  /**
   * Horizontal position of the ripple center.
   */
  rippleX: PropTypes.number,
  /**
   * Vertical position of the ripple center.
   */
  rippleY: PropTypes.number
} : {};

export default Ripple;