'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _clsx3 = require('clsx');

var _clsx4 = _interopRequireDefault(_clsx3);

var _reactTransitionGroup = require('react-transition-group');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * @ignore - internal component.
 */
function Ripple(props) {
  var _clsx, _clsx2;

  var _props$classes = props.classes,
      classes = _props$classes === undefined ? {} : _props$classes,
      className = props.className,
      _props$pulsate = props.pulsate,
      pulsate = _props$pulsate === undefined ? false : _props$pulsate,
      rippleX = props.rippleX,
      rippleY = props.rippleY,
      rippleSize = props.rippleSize,
      other = _objectWithoutProperties(props, ['classes', 'className', 'pulsate', 'rippleX', 'rippleY', 'rippleSize']);

  var _React$useState = _react2.default.useState(false),
      visible = _React$useState[0],
      setVisible = _React$useState[1];

  var _React$useState2 = _react2.default.useState(false),
      leaving = _React$useState2[0],
      setLeaving = _React$useState2[1];

  var handleEnter = function handleEnter() {
    setVisible(true);
  };

  var handleExit = function handleExit() {
    setLeaving(true);
  };

  var rippleClassName = (0, _clsx4.default)(classes.ripple, (_clsx = {}, _clsx[classes.rippleVisible] = visible, _clsx[classes.ripplePulsate] = pulsate, _clsx), className);

  var rippleStyles = {
    width: rippleSize,
    height: rippleSize,
    top: -(rippleSize / 2) + rippleY,
    left: -(rippleSize / 2) + rippleX
  };

  var childClassName = (0, _clsx4.default)(classes.child, (_clsx2 = {}, _clsx2[classes.childLeaving] = leaving, _clsx2[classes.childPulsate] = pulsate, _clsx2));

  return _react2.default.createElement(
    _reactTransitionGroup.Transition,
    _extends({ onEnter: handleEnter, onExit: handleExit }, other),
    _react2.default.createElement(
      'span',
      { className: rippleClassName, style: rippleStyles },
      _react2.default.createElement('span', { className: childClassName })
    )
  );
}

Ripple.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: _propTypes2.default.object.isRequired,
  /**
   * @ignore
   */
  className: _propTypes2.default.string,
  /**
   * If `true`, the ripple pulsates, typically indicating the keyboard focus state of an element.
   */
  pulsate: _propTypes2.default.bool,
  /**
   * Diameter of the ripple.
   */
  rippleSize: _propTypes2.default.number,
  /**
   * Horizontal position of the ripple center.
   */
  rippleX: _propTypes2.default.number,
  /**
   * Vertical position of the ripple center.
   */
  rippleY: _propTypes2.default.number
} : {};

exports.default = Ripple;
module.exports = exports['default'];